﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Binding.AccessCollectionNonUi
{
    /// <summary>
    /// Interaction logic for AccessCollectionNonUiView.xaml
    /// </summary>
    public partial class AccessCollectionNonUiView : UserControl
    {
        private object _personsLock = new object();
        public ObservableCollection<Person> Persons { get; private set; }

        public AccessCollectionNonUiView()
        {
            this.DataContext = this;
            Persons = new ObservableCollection<Person>();
            BindingOperations.EnableCollectionSynchronization(Persons, _personsLock);

            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Task.Run(() =>
            {
                for (int i = 0; i < 1000; i++)
                {
                    Thread.Sleep(10);
                    //this.Dispatcher.Invoke(() =>
                    Persons.Add(new Person { Name = "Person " + i, Age = 20 + i })
                        //)
                    ;
                }
            });
        }
    }
}
