﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace CallerInfo
{
    public static class Logger
    {
        public static void Log(
            [CallerFilePath]string file = "",
            [CallerMemberName] string method = "",
            [CallerLineNumber]int line = -1)
        {
            Debug.WriteLine(string.Format("{0}: {1} {2} {3}", DateTime.Now, file, method, line));
        }
    }
}
